(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      8210,        219]
NotebookOptionsPosition[      7744,        198]
NotebookOutlinePosition[      8121,        215]
CellTagsIndexPosition[      8078,        212]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Be", " ", "sure", " ", "you", " ", "have", " ", "loaded", " ", "the", " ", 
   "functions", " ", "from", " ", 
   RowBox[{"functions", ".", "nb"}], " ", "and", " ", 
   RowBox[{"FourierIdentity", ".", 
    RowBox[{"nb", " ", "!"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.550253120759425*^9, 3.550253138851248*^9}, {
  3.550253690334671*^9, 3.550253691553851*^9}, {3.552933604937656*^9, 
  3.552933605193698*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Evaluate", " ", "this", " ", "cell"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"n", "=", "7"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"input", "=", 
     RowBox[{"Chains", "[", 
      RowBox[{
       RowBox[{"Range", "[", "n", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", "1", "}"}], "}"}], ",", "True"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Js", "=", 
     RowBox[{"Subsets", "[", 
      RowBox[{"Range", "[", 
       RowBox[{"2", ",", "n"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"output", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Computes", " ", "the", " ", "sum", " ", "over", " ", "chains", " ", 
      "for", " ", "a", " ", "single", " ", "fixed", " ", "J", " ", "set"}], 
     ",", " ", 
     RowBox[{"and", " ", "simplifies", " ", "it"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"innerSumJ", "[", "J_", "]"}], ":=", "\[IndentingNewLine]", 
     RowBox[{"SumOver", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"ProdTerm", "[", 
            RowBox[{"#", ",", 
             RowBox[{"Range", "[", "n", "]"}]}], "]"}], "//", 
           "Minimal\[Phi]Terms"}], "//", "ThrowAwayZeros"}], ")"}], "&"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"JSymDif", "[", 
           RowBox[{"J", ",", "#"}], "]"}], "&"}], ",", "input"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5492164953539743`*^9, 3.549216588580956*^9}, {
   3.5492166516138697`*^9, 3.549216806406927*^9}, {3.54921694346733*^9, 
   3.549216996490902*^9}, {3.5492173221874123`*^9, 3.549217322370677*^9}, {
   3.549218234010722*^9, 3.549218234807867*^9}, {3.5492184281503277`*^9, 
   3.549218440735038*^9}, {3.549218547639559*^9, 3.549218583485311*^9}, {
   3.549218840273361*^9, 3.549218846856711*^9}, {3.55009262936438*^9, 
   3.550092634871827*^9}, 3.550092784279533*^9, {3.55009301995325*^9, 
   3.550093020112529*^9}, {3.55009307358878*^9, 3.550093077796146*^9}, {
   3.550093117824049*^9, 3.550093127405751*^9}, {3.55009323365132*^9, 
   3.5500932970592937`*^9}, {3.5500933336260557`*^9, 3.550093364826755*^9}, {
   3.550093396908983*^9, 3.550093419817988*^9}, {3.5500939642783337`*^9, 
   3.550093964749235*^9}, {3.5500940321795807`*^9, 3.5500940322972193`*^9}, {
   3.550094075578532*^9, 3.5500940758570766`*^9}, {3.550094520155924*^9, 
   3.550094520305503*^9}, {3.5502529026205473`*^9, 3.550252907601347*^9}, {
   3.550252978088875*^9, 3.550252996887794*^9}, {3.550253703892612*^9, 
   3.5502537137255096`*^9}, {3.5502537486145*^9, 3.550253749492207*^9}, {
   3.550253837181108*^9, 3.5502538875706053`*^9}, {3.5529336120661077`*^9, 
   3.5529336151507263`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Now", " ", "evaluate", " ", "this", " ", 
      RowBox[{"cell", ".", " ", "If"}], " ", "n"}], "=", "6"}], ",", " ", 
    RowBox[{
     RowBox[{
     "you", " ", "have", " ", "time", " ", "for", " ", "a", " ", "cup", " ", 
      "of", " ", 
      RowBox[{"coffee", ".", " ", "If"}], " ", "n"}], "=", "7"}], ",", " ", 
    RowBox[{"come", " ", "back", " ", "this", " ", 
     RowBox[{"afternoon", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Iterates", " ", "over", " ", "J"}], ",", " ", 
    RowBox[{
    "computing", " ", "the", " ", "inner", " ", "sum", " ", "for", " ", 
     "each", " ", 
     RowBox[{"J", ".", " ", "Displays"}], " ", "an", " ", "updating", " ", 
     "value", " ", "for", " ", "i"}], ",", " ", 
    RowBox[{
    "so", " ", "you", " ", "can", " ", "track", " ", "progress", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"it", " ", "is", " ", "slow"}], ";", " ", 
        RowBox[{
         RowBox[{"for", " ", "n"}], "=", "7"}]}], ",", " ", 
       RowBox[{"time", " ", "is", " ", "a", " ", "few", " ", "hours"}]}], 
      ")"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"Length", "[", "Js", "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{"Dynamic", "[", "i", "]"}], "\[IndentingNewLine]", 
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"i", "=", "1"}], ",", 
     RowBox[{"i", "\[LessEqual]", 
      RowBox[{"Length", "[", "Js", "]"}]}], ",", 
     RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"output", "+=", 
       RowBox[{"innerSumJ", "[", 
        RowBox[{"Js", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
   "output"}]}]], "Input",
 CellChangeTimes->{{3.5492164953539743`*^9, 3.549216588580956*^9}, {
   3.5492166516138697`*^9, 3.549216806406927*^9}, {3.54921694346733*^9, 
   3.549216996490902*^9}, {3.5492173221874123`*^9, 3.549217322370677*^9}, {
   3.549218234010722*^9, 3.549218234807867*^9}, {3.5492184281503277`*^9, 
   3.549218440735038*^9}, {3.549218547639559*^9, 3.549218583485311*^9}, {
   3.549218840273361*^9, 3.549218846856711*^9}, {3.55009262936438*^9, 
   3.550092634871827*^9}, 3.550092784279533*^9, {3.55009301995325*^9, 
   3.550093020112529*^9}, {3.55009307358878*^9, 3.550093077796146*^9}, 
   3.550093117824049*^9, {3.550094568642939*^9, 3.5500946068229856`*^9}, {
   3.550252999182527*^9, 3.5502530684928493`*^9}, {3.550253716712097*^9, 
   3.550253739755301*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "If", " ", "this", " ", "is", " ", "0", " ", "or", " ", "a", " ", 
     "multiple", " ", "of", " ", 
     RowBox[{"\[Phi]", "[", 
      RowBox[{"{", "}"}], "]"}]}], ",", " ", 
    RowBox[{
    "you", " ", "have", " ", "proven", " ", "the", " ", "Fourier", " ", 
     "Identity", " ", "for", " ", 
     RowBox[{"n", "."}]}]}], " ", "*)"}], 
  RowBox[{"output", "-", 
   RowBox[{"ETermSum", "[", "n", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.550112478950615*^9, 3.550112483707367*^9}, {
  3.550252958949338*^9, 3.550252959642844*^9}, {3.5502537599125137`*^9, 
  3.550253789592823*^9}}],

Cell[BoxData[
 RowBox[{"542", " ", 
  RowBox[{"\[Phi]", "[", 
   RowBox[{"{", "}"}], "]"}]}]], "Output",
 CellChangeTimes->{{3.55025375359875*^9, 3.550253760500319*^9}, 
   3.5502538554198093`*^9}]
}, Open  ]]
},
WindowSize->{740, 569},
WindowMargins->{{44, Automatic}, {-4, Automatic}},
ShowSelection->True,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 6, \
2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 471, 10, 27, "Input"],
Cell[1031, 32, 3092, 71, 208, "Input"],
Cell[4126, 105, 2717, 62, 193, "Input"],
Cell[CellGroupData[{
Cell[6868, 171, 660, 17, 43, "Input"],
Cell[7531, 190, 197, 5, 27, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
